function result = atan2Int(y,x)

if isempty(y.inf) || isempty(y.inf)
    result = intval();
    return
end

result = [];
vectSize = length(x.inf);
ival = 1;
if isa(x,'interval') || isa(x,'intval')
    if isa(x,'intval'), intvl = 1; else intvl = 0; end
    ival = 2;
    tmp = atan2(y.mid,x.mid);
    a(:,:,1) = (tmp > 1.5708);
    a(:,:,2) = (tmp < 1.5708 & tmp >= 0);
    a(:,:,3) = (tmp >= -1.5708 & tmp < 0);
    a(:,:,4) = (tmp < -1.5708);
    [dummy, qdrnt] = max(a,[],3); clear dummy
    xtmp = zeros([size(x.inf),2]);
    tmp1 = zeros(size(x.inf));
    tmp1(qdrnt == 1 | qdrnt == 3) = x.inf(qdrnt == 1 | qdrnt == 3)';
    xtmp(:,:,1) = tmp1;
    tmp1(qdrnt == 1 | qdrnt == 3) = x.sup(qdrnt == 1 | qdrnt == 3)';
    xtmp(:,:,2) = tmp1;
    tmp1(qdrnt == 2 | qdrnt == 4) = x.sup(qdrnt == 2 | qdrnt == 4);
    xtmp(:,:,1) = tmp1;
    tmp1(qdrnt == 2 | qdrnt == 4) = x.inf(qdrnt == 2 | qdrnt == 4);
    xtmp(:,:,2) = tmp1;
    x = xtmp;
    tmp1 = y.inf;
    ytmp(:,:,1) = tmp1;
    tmp1 = y.sup;
    ytmp(:,:,2) = tmp1;
    y = ytmp;
end

resultTmp = atan(y./x);
result = zeros(size(resultTmp));

xGrZero = x > 0;
xLZero = x < 0;
yGrEZero = y >= 0;
yGrZero = y > 0;
yLZero = y < 0;

result(xGrZero) = resultTmp(xGrZero);
result(~xGrZero & xLZero & yGrEZero) = resultTmp(xLZero & yGrEZero) + pi;
result(~xGrZero & xLZero & yLZero) = resultTmp(xLZero & yLZero) - pi;
result(~xGrZero & ~xLZero & yGrZero) = pi/2;
result(~xGrZero & ~xLZero & yLZero) = -pi/2;
result(~xGrZero & ~xLZero & ~yLZero & ~yGrZero) = NaN;

if ival == 2
    fixRes = isnan(result);
    result(fixRes) = 10^-100;

    result = sort(result,3);
    if ~isempty(result)
        if intvl
            result = infsup(result(:,:,1),result(:,:,2));
        else
            result = interval(result(:,:,1),result(:,:,2));
        end
    end
else
    fprintf('Check!!!\n')
    result = result';
end

if isempty(result)
    if intvl
        result = intval();
    else
        result = interval();
    end
end
end