function [pp measurements, measVolumes] = contractParticlesA(particles, measurements, mm, contrIt, grd,partPrev,Birth)

numMeas = length([measurements.b]);
numPart = size(particles,2);
particlesR = repmat(particles(5,:)',1,numMeas);
particlesX = repmat(particles(1,:)',1,numMeas);
particlesY = repmat(particles(3,:)',1,numMeas);
particlesXv = repmat(particles(2,:)',1,numMeas);
particlesYv = repmat(particles(4,:)',1,numMeas);
particlesXprev = repmat(partPrev(1,:)',1,numMeas);
particlesYprev = repmat(partPrev(3,:)',1,numMeas);
Birth = repmat(Birth,1,numMeas);
Ts = 1;

for c = 1:contrIt
    for s = 1:length(mm)-1
        [measCartX measCartY] = pol2cart(measurements(s).b,measurements(s).d);
        measCart(s).x = measCartX + grd(s).Xsen;
        measCart(s).y = measCartY + grd(s).Ysen;
    end
    measurementsX = [measCart.x];
    measurementsY = [measCart.y];
    if c == 1
        measurementsX = repmat(measurementsX,numPart,1);
        measurementsY = repmat(measurementsY,numPart,1);
    end
    
    particlesRnew = sqrt((measurementsX - particlesX).^2 + (measurementsY - particlesY).^2);
    particlesR = intersect(particlesR, particlesRnew);
    
    tmp = (particlesR.^2 - (measurementsY - particlesY).^2);
    tmp(tmp.sup < 0) = infsup(NaN,NaN);
    tmp(tmp.inf < 0) = infsup(0,tmp(tmp.inf < 0).sup);
    particlesXnew = measurementsX - sqrt(tmp);
    particlesXnew = hull(particlesXnew,measurementsX + sqrt(tmp));
    particlesX = intersect(particlesX, particlesXnew);
    
    tmp = particlesR.^2 - (measurementsX - particlesX).^2;
    tmp(tmp.sup < 0) = infsup(NaN,NaN);
    tmp(tmp.inf < 0) = infsup(0,tmp(tmp.inf < 0).sup);
    particlesYnew = measurementsY - sqrt(tmp);
    particlesYnew = hull(particlesYnew,measurementsY + sqrt(tmp));
    particlesY = intersect(particlesY, particlesYnew);
    
    particlesXvnew = (particlesX - particlesXprev) / Ts;
    particlesXv(~Birth) = intersect(particlesXv(~Birth), particlesXvnew(~Birth)); 
    particlesYvnew = (particlesY - particlesYprev) / Ts;
    particlesYv(~Birth) = intersect(particlesYv(~Birth), particlesYvnew(~Birth));

    tmp =(particlesR.^2 - (measurementsY - particlesY).^2);
    tmp(tmp.inf < 0) = infsup(0,tmp(tmp.inf < 0).sup);
    tmp(tmp.sup < 0) = infsup(NaN,NaN);
    measurementsXnew = particlesX - sqrt(tmp);
    measurementsXnew = hull(measurementsXnew,particlesX + sqrt(tmp));
    measurementsX = intersect(measurementsX, measurementsXnew);
    
    tmp =(particlesR.^2 - (measurementsX - particlesX).^2);
    tmp(tmp.inf < 0) = infsup(0,tmp(tmp.inf < 0).sup);
    tmp(tmp.sup < 0) = infsup(NaN,NaN);
    measurementsYnew = particlesY - sqrt(tmp);
    measurementsYnew = hull(measurementsYnew,particlesY + sqrt(tmp));
    measurementsY = intersect(measurementsY, measurementsYnew);
    
    for s = 1:length(mm)-1
        rnge = sum(mm(1:s))+1:sum(mm(1:s))+mm(s+1);
        if ~isempty(rnge)
            if c == 1
                intMb = repmat(measurements(s).b,numPart,1);
                intMd = repmat(measurements(s).d,numPart,1);
            else
                intMb = measurements(s).b;
                intMd = measurements(s).d;
            end
            
            measurementsNewb = atan2Int(measurementsY(:,rnge) - grd(s).Ysen, measurementsX(:,rnge) - grd(s).Xsen);
            measurements(s).b = intersect(intMb,measurementsNewb);
            measurementsNewd = sqrt((measurementsX(:,rnge) - grd(s).Xsen).^2 + (measurementsY(:,rnge) - grd(s).Ysen).^2);
            measurements(s).d = intersect(intMd,measurementsNewd);
        end
    end
end

measB = [measurements.b];
measD = [measurements.d];
measVolumes = measB.rad.*pi.*measD.sup - measB.rad.*pi.*measD.inf;
measVolumes(isnan(measVolumes)) = 0;

pp(1,:,:) = particlesX;
pp(2,:,:) = particlesXv;
pp(3,:,:) = particlesY;
pp(4,:,:) = particlesYv;
pp(5,:,:) = particlesR;

end