function [x1,weights] = generateParticles(x, param)

if (param.numParticles == 32)
    lx = linspace(x(1).inf,x(1).sup,3);
    lxIn = infsup(lx(1:end-1),lx(2:end));
    lxv = linspace(x(2).inf,x(2).sup,3);
    lxvIn = infsup(lxv(1:end-1),lxv(2:end));
    ly = linspace(x(3).inf,x(3).sup,3);
    lyIn = infsup(ly(1:end-1),ly(2:end));
    lyv = linspace(x(4).inf,x(4).sup,3);
    lyvIn = infsup(lyv(1:end-1),lyv(2:end));
    lR = linspace(x(5).inf,x(5).sup,3);
    lRIn = infsup(lR(1:end-1),lR(2:end));
    s = 0;
    for i = 1:2
        for j = 1:2
            for k = 1:2
                for l = 1:2
                    for m = 1:2
                        s = s + 1;
                        x1(1,s) = lxIn(i);
                        x1(3,s) = lyIn(j);
                        x1(2,s) = lxvIn(k);
                        x1(4,s) = lyvIn(l);
                        x1(5,s) = lRIn(m);
                    end
                end
            end
        end
    end
elseif(param.numParticles == 16)
    lx = linspace(x(1).inf,x(1).sup,3);
    lxIn = infsup(lx(1:end-1),lx(2:end));
    lxv = linspace(x(2).inf,x(2).sup,3);
    lxvIn = infsup(lxv(1:end-1),lxv(2:end));
    ly = linspace(x(3).inf,x(3).sup,3);
    lyIn = infsup(ly(1:end-1),ly(2:end));
    lyv = linspace(x(4).inf,x(4).sup,3);
    lyvIn = infsup(lyv(1:end-1),lyv(2:end));
    lRIn = infsup(x(5).inf,x(5).sup);
    s = 0;
    for i = 1:2
        for j = 1:2
            for k = 1:2
                for l = 1:2
                    s = s + 1;
                    x1(1,s) = lxIn(i);
                    x1(3,s) = lyIn(j);
                    x1(2,s) = lxvIn(k);
                    x1(4,s) = lyvIn(l);
                    x1(5,s) = lRIn;
                end
            end
        end
    end
elseif(param.numParticles == 4)
    lx = linspace(x(1).inf,x(1).sup,3);
    lxIn = infsup(lx(1:end-1),lx(2:end));
    lxvIn = infsup(x(2).inf,x(2).sup);
    ly = linspace(x(3).inf,x(3).sup,3);
    lyIn = infsup(ly(1:end-1),ly(2:end));
    lyvIn = infsup(x(4).inf,x(4).sup);
    lRIn = infsup(x(5).inf,x(5).sup);
    s = 0;
    for i = 1:2
        for j = 1:2
            s = s + 1;
            x1(1,s) = lxIn(i);
            x1(3,s) = lyIn(j);
            x1(2,s) = lxvIn;
            x1(4,s) = lyvIn;
            x1(5,s) = lRIn;
        end
    end
else
    error("Choose between 4/16/32 box particles")
end
weights = 1/param.numParticles*ones(param.numParticles,1);

x1(5,:) = abs(x1(5,:));
end